Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr19.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr19.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr19.java	(working copy)
@@ -69,7 +69,7 @@
 				index |= flag;
 				lastName = name;
 			}
-			writer.putN(n, index);
+			writer.putNu(n, index);
 
 			int type = MdrUtils.fullTypeToNaturalType(p.getType());
 			if (type != lastType) {
@@ -84,7 +84,7 @@
 
 		Mdr18Record m18 = new Mdr18Record();
 		m18.setRecord(record);
-		m18.setType(~0);
+		m18.setType(0xffff);
 		poiTypes.add(m18);
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr1MapIndex.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr1MapIndex.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr1MapIndex.java	(working copy)
@@ -44,7 +44,7 @@
 	}
 
 	public void addPointer(int recordNumber) {
-		subWriter.putN(pointerSize, recordNumber);
+		subWriter.putNu(pointerSize, recordNumber);
 	}
 	
 	private int sectionToSubsection(int n) {
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr1SubHeader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr1SubHeader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr1SubHeader.java	(working copy)
@@ -42,7 +42,7 @@
 	}
 
 	protected void writeFileHeader(ImgFileWriter writer) {
-		writer.putChar((char) HEADER_SIZE);
+		writer.put2u(HEADER_SIZE);
 		for (int n = 1; n <= MAX_SECTION; n++) {
 			Section section = sections[n];
 
@@ -49,15 +49,15 @@
 			// The second subsection does not have a length, because it always
 			// has the same length as subsection 1.
 			if (n == 2)
-				writer.putInt(section.getPosition());
+				writer.put4(section.getPosition());
 			else {
 				//section.writeSectionInfo(writer);
-				writer.putInt(section.getPosition());
+				writer.put4(section.getPosition());
 				int size = section.getSize();
 				if (size == 0)
-					writer.putInt(0);
+					writer.put4(0);
 				else
-					writer.putInt(size / section.getItemSize());
+					writer.put4(size / section.getItemSize());
 			}
 		}
 	}
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr23.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr23.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr23.java	(working copy)
@@ -77,9 +77,9 @@
 				lastName = name;
 			}
 
-			writer.putChar((char) reg.getRegionIndex());
-			writer.putChar((char) reg.getCountryIndex());
-			writer.put3(reg.getLblOffset() | flag);
+			writer.put2u(reg.getRegionIndex());
+			writer.put2u(reg.getCountryIndex());
+			writer.put3u(reg.getLblOffset() | flag);
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr24.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr24.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr24.java	(working copy)
@@ -79,8 +79,8 @@
 				lastName = name;
 			}
 
-			writer.putChar((char) c.getCountryIndex());
-			writer.put3(c.getLblOffset() | flag);
+			writer.put2u(c.getCountryIndex());
+			writer.put3u(c.getLblOffset() | flag);
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr25.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr25.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr25.java	(working copy)
@@ -81,7 +81,7 @@
 	public void writeSectData(ImgFileWriter writer) {
 		int size = getItemSize();
 		for (Mdr5Record city : cities) {
-			writer.putN(size,  city.getGlobalCityIndex());
+			writer.putNu(size,  city.getGlobalCityIndex());
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr26.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr26.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr26.java	(working copy)
@@ -74,7 +74,7 @@
 	public void writeSectData(ImgFileWriter writer) {
 		int size = getSizes().getSize(28);
 		for (Mdr28Record record : index) {
-			writer.putN(size, record.getIndex());
+			writer.putNu(size, record.getIndex());
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr27.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr27.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr27.java	(working copy)
@@ -76,7 +76,7 @@
 	public void writeSectData(ImgFileWriter writer) {
 		int size = getItemSize();
 		for (Mdr5Record city : cities) {
-			writer.putN(size,  city.getGlobalCityIndex());
+			writer.putNu(size,  city.getGlobalCityIndex());
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr28.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr28.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr28.java	(working copy)
@@ -73,10 +73,10 @@
 		int size27 = sizes.getSize(27);
 
 		for (Mdr28Record mdr28 : index) {
-			writer.putN(size23, mdr28.getMdr23());
+			writer.putNu(size23, mdr28.getMdr23());
 			putStringOffset(writer, mdr28.getStrOffset());
-			writer.putN(size21, mdr28.getMdr21());
-			writer.putN(size27, mdr28.getMdr27());
+			writer.putNu(size21, mdr28.getMdr21());
+			writer.putNu(size27, mdr28.getMdr27());
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr29.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr29.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr29.java	(working copy)
@@ -85,15 +85,15 @@
 		int size26 = has26? sizes.getSize(26): 0;
 		int size17 = Utils.numberToPointerSize(max17);
 		for (Mdr29Record record : index) {
-			writer.putN(size24, record.getMdr24());
+			writer.putNu(size24, record.getMdr24());
 			if (hasString)
 				putStringOffset(writer, record.getStrOffset());
-			writer.putN(size22, record.getMdr22());
-			writer.putN(size25, record.getMdr25());
+			writer.putNu(size22, record.getMdr22());
+			writer.putNu(size25, record.getMdr25());
 			if (has26)
-				writer.putN(size26, record.getMdr26());
+				writer.putNu(size26, record.getMdr26());
 			if (has17)
-				writer.putN(size17, record.getMdr17());
+				writer.putNu(size17, record.getMdr17());
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr2x.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr2x.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr2x.java	(working copy)
@@ -62,15 +62,15 @@
 				if (repeat != 0)
 					offset |= 0x800000;
 
-				writer.put3(offset);
+				writer.put3u(offset);
 				if (writeNameOffset)
-					writer.put(street.getOutNameOffset());
+					writer.put1u(street.getOutNameOffset());
 
 				if (partialInfoSize > 0) {
 					int trailingFlags = ((rr & 1) == 0) ? 1 : 0;
 					// trailingFlags |= s.getB() << 1;
 					// trailingFlags |= s.getS() << (1 + partialBShift);
-					writer.putN(partialInfoSize, trailingFlags);
+					writer.putNu(partialInfoSize, trailingFlags);
 				}
 			} else {
 				int rr = street.checkFullRepeat(prev, collator);
@@ -78,7 +78,7 @@
 					repeat = 0;
 
 				int index = street.getIndex();
-				writer.putN(size, (index << 1) | repeat);
+				writer.putNu(size, (index << 1) | repeat);
 			}
 
 			prev = street;
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr4.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr4.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr4.java	(working copy)
@@ -40,9 +40,9 @@
 		Collections.sort(list);
 
 		for (Mdr4Record r : list) {
-			writer.put((byte) r.getType());
-			writer.put((byte) r.getUnknown());
-			writer.put((byte) r.getSubtype());
+			writer.put1u(r.getType());
+			writer.put1u(r.getUnknown());
+			writer.put1u(r.getSubtype());
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr5.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr5.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr5.java	(working copy)
@@ -212,12 +212,12 @@
 			// Write out the record
 			putMapIndex(writer, mapIndex);
 			putLocalCityIndex(writer, city.getCityIndex());
-			writer.put3(flag | city.getLblOffset());
+			writer.put3u(flag | city.getLblOffset());
 			if (hasRegion)
-				writer.putChar((char) region);
+				writer.put2u(region);
 			if (hasString)
 				putStringOffset(writer, city.getStringOffset());
-			writer.putN(size20, city.getMdr20());
+			writer.putNu(size20, city.getMdr20());
 		}
 	}
 
@@ -226,7 +226,7 @@
 	 * and not the global city index used in mdr11.
 	 */
 	private void putLocalCityIndex(ImgFileWriter writer, int cityIndex) {
-		writer.putN(localCitySize, cityIndex);
+		writer.putNu(localCitySize, cityIndex);
 	}
 
 	/**
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr6.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr6.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr6.java	(working copy)
@@ -56,7 +56,7 @@
 			addIndexPointer(z.getMapIndex(), record++);
 
 			putMapIndex(writer, z.getMapIndex());
-			writer.putN(zipSize, z.getZipIndex());
+			writer.putNu(zipSize, z.getZipIndex());
 			if (hasString)
 				putStringOffset(writer, z.getStringOffset());
 		}
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr7.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr7.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr7.java	(working copy)
@@ -357,17 +357,17 @@
 			if (rr != 3)
 				lab |= 0x800000;
 			
-			writer.put3(lab);
+			writer.put3u(lab);
 			if (hasStrings)
 				putStringOffset(writer, s.getStringOffset());
 
 			if (hasNameOffset)
-				writer.put(s.getOutNameOffset());
+				writer.put1u(s.getOutNameOffset());
 			if (partialInfoSize > 0) {
 				int trailingFlags = ((rr & 1) == 0) ? 1 : 0;
 				// trailingFlags |= s.getB() << 1;
 				// trailingFlags |= s.getS() << (1 + partialBShift);
-				writer.putN(partialInfoSize, trailingFlags);
+				writer.putNu(partialInfoSize, trailingFlags);
 			}
 			last = s;
 		}
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr8.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr8.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr8.java	(working copy)
@@ -42,9 +42,9 @@
 		int size = associatedSize();
 		for (Mdr8Record s : index) {
 			for (int i = 0; i< STRING_WIDTH; i++) {
-				writer.put((byte) s.getPrefix()[i]);
+				writer.put1u(s.getPrefix()[i]);
 			}
-			writer.putN(size, s.getRecordNumber());
+			writer.putNu(size, s.getRecordNumber());
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr9.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr9.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr9.java	(working copy)
@@ -35,8 +35,8 @@
 		int poiSize = getSizes().getPoiSize();
 		for (Map.Entry<Integer, Integer> ent : index.entrySet()) {
 			int group = ent.getKey();
-			writer.put((byte) group);
-			writer.putN(poiSize, ent.getValue());
+			writer.put1u(group);
+			writer.putNu(poiSize, ent.getValue());
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/MdrMapSection.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/MdrMapSection.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/MdrMapSection.java	(working copy)
@@ -53,18 +53,18 @@
 
 	protected void putCityIndex(ImgFileWriter writer, int cityIndex, boolean isNew) {
 		int flag = (isNew && cityIndex > 0)? getSizes().getCityFlag(): 0;
-		writer.putN(getSizes().getCitySizeFlagged(), cityIndex | flag);
+		writer.putNu(getSizes().getCitySizeFlagged(), cityIndex | flag);
 	}
 
 	protected void putRegionIndex(ImgFileWriter writer, int region) {
 		// This is only called when putCityIndex might also be called and so has to be
 		// the same size (probably ;)
-		writer.putN(getSizes().getCitySizeFlagged(), region);
+		writer.putNu(getSizes().getCitySizeFlagged(), region);
 	}
 
 	protected void putPoiIndex(ImgFileWriter writer, int poiIndex, boolean isNew) {
 		int flag = isNew? getSizes().getPoiFlag(): 0;
-		writer.putN(getSizes().getPoiSizeFlagged(), poiIndex | flag);
+		writer.putNu(getSizes().getPoiSizeFlagged(), poiIndex | flag);
 	}
 
 	protected boolean hasFlag(int val) {
Index: src/uk/me/parabola/imgfmt/app/mdr/MdrSection.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/MdrSection.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/MdrSection.java	(working copy)
@@ -49,11 +49,11 @@
 	}
 
 	protected void putMapIndex(ImgFileWriter writer, int mapIndex) {
-		writer.putN(sizes.getMapSize(), mapIndex);
+		writer.putNu(sizes.getMapSize(), mapIndex);
 	}
 
 	protected void putStringOffset(ImgFileWriter writer, int strOff) {
-		writer.putN(sizes.getStrOffSize(), strOff);
+		writer.putNu(sizes.getStrOffSize(), strOff);
 	}
 
 	/**
Index: src/uk/me/parabola/imgfmt/app/mdr/PrefixIndex.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/PrefixIndex.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/PrefixIndex.java	(working copy)
@@ -118,9 +118,9 @@
 		int size = Utils.numberToPointerSize(maxIndex);
 		for (Mdr8Record s : index) {
 			for (int i = 0; i< prefixLength; i++) {
-				writer.put((byte) s.getPrefix()[i]);
+				writer.put1u(s.getPrefix()[i]);
 			}
-			writer.putN(size, s.getRecordNumber());
+			writer.putNu(size, s.getRecordNumber());
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/RecordBase.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/RecordBase.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/mdr/RecordBase.java	(working copy)
@@ -19,7 +19,7 @@
  * @author Steve Ratcliffe
  */
 public abstract class RecordBase {
-	private short mapIndex;
+	private int mapIndex;
 
 	public int getMapIndex() {
 		return mapIndex;
@@ -27,6 +27,6 @@
 
 	public void setMapIndex(int mapIndex) {
 		assert mapIndex > 0;
-		this.mapIndex = (short) mapIndex;
+		this.mapIndex = mapIndex;
 	}
 }
Index: src/uk/me/parabola/imgfmt/app/net/NETFileReader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/NETFileReader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/NETFileReader.java	(working copy)
@@ -91,13 +91,13 @@
 			RoadDef road = new RoadDef(++record, off, null);
 			readLabels(reader, road);
 			byte netFlags = reader.get();
-			/*int len =*/ reader.getu3();
+			/*int len =*/ reader.get3u();
 
 			int[] counts = new int[24];
 			int level = 0;
 			while (level < 24) {
 				int n = reader.get();
-				counts[level++] = (n & 0x7f);
+				counts[level++] = n & 0x7f;
 				if ((n & 0x80) != 0)
 					break;
 			}
@@ -106,12 +106,12 @@
 				int c = counts[i];
 				for (int j = 0; j < c; j++) {
 					/*byte b =*/ reader.get();
-					/*char sub =*/ reader.getChar();
+					/*char sub =*/ reader.get2u();
 				}
 			}
 
 			if ((netFlags & RoadDef.NET_FLAG_ADDRINFO) != 0) {
-				char flags2 = reader.getChar();
+				int flags2 = reader.get2u();
 
 				int zipFlag = (flags2 >> 10) & 0x3;
 				int cityFlag = (flags2 >> 12) & 0x3;
@@ -130,10 +130,10 @@
 			}
 
 			if ((netFlags & RoadDef.NET_FLAG_NODINFO) != 0) {
-				int nodFlags = reader.get();
+				int nodFlags = reader.get1u();
 				int nbytes = nodFlags & 0x3;
 				if (nbytes > 0) {
-					/*int nod = */reader.getUint(nbytes+1);
+					/*int nod = */reader.getNu(nbytes+1);
 				}
 			}
 
@@ -153,16 +153,16 @@
 		indexes.clear();
 		if (flag == 2) {
 			// fetch city/zip index
-			int ind = reader.getUint(size);
+			int ind = reader.getNu(size);
 			if (ind != 0)
 				indexes.add(ind-1);
 		} else if (flag == 3) {
 			// there is no item
 		} else if (flag == 0) {
-			int n = reader.get() & 0xff;
+			int n = reader.get1u();
 			parseList(reader, n, size, indexes);
 		} else if (flag == 1) {
-			int n = reader.getChar();
+			int n = reader.get2u();
 			parseList(reader, n, size, indexes);
 		} else {
 			assert false : "flag is " + flag;
@@ -174,13 +174,13 @@
 		long endPos = reader.position() + n;
 		int node = 0; // not yet used
 		while (reader.position() < endPos) {
-			int initFlag = reader.get() & 0xff;
-			int skip = (initFlag & 0x1f);
+			int initFlag = reader.get1u();
+			int skip = initFlag & 0x1f;
 			initFlag >>= 5;
 			if (initFlag == 7) {
 				// Need to read another byte
-				initFlag = reader.get() & 0xff;
-				skip |= ((initFlag & 0x1f) << 5);
+				initFlag = reader.get1u();
+				skip |= (initFlag & 0x1f) << 5;
 				initFlag >>= 5;
 			}
 			node += skip + 1;
@@ -210,7 +210,7 @@
 			assert false : "ERRROR overflow";
 			return 0;
 		}
-		int cnum = reader.getUint(size);
+		int cnum = reader.getNu(size);
 		return cnum;
 	}
 
@@ -222,9 +222,9 @@
 	private void fetchNumber(ImgFileReader reader, int numberFlag) {
 		int n = 0;
 		if (numberFlag == 0) {
-			n = reader.get();
+			n = reader.get1u();
 		} else if (numberFlag == 1) {
-			n = reader.getChar();
+			n = reader.get2u();
 		} else if (numberFlag == 3) {
 			// There is no block
 			return;
@@ -238,7 +238,7 @@
 
 	private void readLabels(ImgFileReader reader, RoadDef road) {
 		for (int i = 0; i < 4; i++) {
-			int lab = reader.getu3();
+			int lab = reader.get3u();
 			Label label = labels.fetchLabel(lab & 0x7fffff);
 			road.addLabel(label);
 			if ((lab & 0x800000) != 0)
@@ -257,7 +257,7 @@
 		int start = netHeader.getRoadDefinitionsStart();
 		for (int off : offsets) {
 			reader.position(start + off);
-			int labelOffset = reader.getu3();
+			int labelOffset = reader.get3u();
 			// TODO what if top bit is not set?, there can be more than one name and we will miss them
 			offsetLabelMap.put(off, labelOffset & 0x7fffff);
 		}
@@ -277,7 +277,7 @@
 
 		Set<Integer> allOffsets = new HashSet<>();
 		while (reader.position() < end) {
-			int net1 = reader.getu3();
+			int net1 = reader.get3u();
 
 			// The offset is stored in the bottom 22 bits. The top 2 bits are an index into the list
 			// of lbl pointers in the net1 entry. 
Index: src/uk/me/parabola/imgfmt/app/net/NETHeader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/NETHeader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/NETHeader.java	(working copy)
@@ -37,8 +37,8 @@
 	private final Section segmentedRoads = new Section(roadDefinitions);
 	private final Section sortedRoads = new Section(segmentedRoads, SORTED_ROAD_RECSIZE);
 
-	private byte roadShift;
-	private byte segmentShift;
+	private int roadShift;
+	private int segmentShift;
 
 	public NETHeader() {
 		super(HEADER_LEN, "GARMIN NET");
@@ -53,14 +53,14 @@
 	 */
 	protected void readFileHeader(ImgFileReader reader) throws ReadFailedException {
 		roadDefinitions.readSectionInfo(reader, false);
-		roadShift = reader.get();
+		roadShift = reader.get1u();
 
 		segmentedRoads.readSectionInfo(reader, false);
-		segmentShift = reader.get();
+		segmentShift = reader.get1u();
 
 		sortedRoads.readSectionInfo(reader, true);
 
-		reader.getInt();
+		reader.get4();
 		reader.get();
 		reader.get();
 	}
@@ -74,17 +74,17 @@
 	protected void writeFileHeader(ImgFileWriter writer) {
 		roadDefinitions.writeSectionInfo(writer);
 
-		writer.put(roadShift); // offset multiplier
+		writer.put1u(roadShift); // offset multiplier
 
 		segmentedRoads.writeSectionInfo(writer);
 
-		writer.put(segmentShift); // offset multiplier
+		writer.put1u(segmentShift); // offset multiplier
 
 		sortedRoads.writeSectionInfo(writer);
 
-		writer.putInt(0);
-		writer.put((byte) 1);
-		writer.put((byte) 0);
+		writer.put4(0);
+		writer.put1u(1);
+		writer.put1u(0);
 	}
 
 	ImgFileWriter makeRoadWriter(ImgFileWriter writer) {
@@ -110,6 +110,6 @@
 	}
 
 	public int getRoadShift() {
-		return roadShift & 0xff;
+		return roadShift;
 	}
 }
Index: src/uk/me/parabola/imgfmt/app/net/NODFile.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/NODFile.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/NODFile.java	(working copy)
@@ -164,7 +164,7 @@
 		pos = (pos + 0x200) & ~0x1ff; // align on 0x200  
 		int numBytesToWrite = pos - section.getPosition();
 		for (int i = 0; i < numBytesToWrite; i++)
-			getWriter().put((byte)0); 
+			getWriter().put1u(0);
 		section.setPosition(pos);
 		ImgFileWriter writer = new SectionWriter(getWriter(), section);
 		
Index: src/uk/me/parabola/imgfmt/app/net/NODHeader.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/NODHeader.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/NODHeader.java	(working copy)
@@ -63,23 +63,23 @@
 	 */
 	protected void readFileHeader(ImgFileReader reader) throws ReadFailedException {
         nodes.readSectionInfo(reader, false);
-        flags = reader.getChar();
-        reader.getChar();
-        align = reader.get();
-        mult1 = reader.get();
-        tableARecordLen = reader.getChar();
+        flags = reader.get2u();
+        reader.get2u();
+        align = reader.get1u();
+        mult1 = reader.get1u();
+        tableARecordLen = reader.get2u();
         roads.readSectionInfo(reader, false);
-        reader.getInt();
+        reader.get4();
         boundary.readSectionInfo(reader, true);
-		reader.getInt();
+		reader.get4();
 		if (getHeaderLength() > 0x3f) {
 			highClassBoundary.readSectionInfo(reader, false);
 
-			classBoundaries[0] = reader.getInt();
-			classBoundaries[1] = classBoundaries[0] + reader.getInt();
-			classBoundaries[2] = classBoundaries[1] + reader.getInt();
-			classBoundaries[3] = classBoundaries[2] + reader.getInt();
-			classBoundaries[4] = classBoundaries[3] + reader.getInt();
+			classBoundaries[0] = reader.get4();
+			classBoundaries[1] = classBoundaries[0] + reader.get4();
+			classBoundaries[2] = classBoundaries[1] + reader.get4();
+			classBoundaries[3] = classBoundaries[2] + reader.get4();
+			classBoundaries[4] = classBoundaries[3] + reader.get4();
 		}
 	}
 
@@ -109,23 +109,23 @@
 		if(driveOnLeft)
 			flags |= 0x0100;
 		
-		writer.putInt(flags);
+		writer.put4(flags);
 
-		byte align = DEF_ALIGN;
-		writer.put(align);
-		writer.put((byte) 0); // pointer multiplier
-		writer.putChar((char) 5);
+		int align = DEF_ALIGN;
+		writer.put1u(align);
+		writer.put1u(0); // pointer multiplier
+		writer.put2u(5);
 
 		roads.writeSectionInfo(writer);
-		writer.putInt(0);
+		writer.put4(0);
 
 		boundary.writeSectionInfo(writer);
 		// new fields for header length > 0x3f
-		writer.putInt(2); // no other value spotted, meaning ?
+		writer.put4(2); // no other value spotted, meaning ?
 		highClassBoundary.writeSectionInfo(writer);
-		writer.putInt(classBoundaries[0]);
+		writer.put4(classBoundaries[0]);
 		for (int i = 1; i < classBoundaries.length; i++){
-			writer.putInt(classBoundaries[i] - classBoundaries[i-1]);
+			writer.put4(classBoundaries[i] - classBoundaries[i-1]);
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/net/RoadDef.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/RoadDef.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/RoadDef.java	(working copy)
@@ -223,8 +223,8 @@
 		if (numbers != null && numbers.getSwapped()) {
 			netFlags |= 0x20; // swapped default; left=even, right=odd
 		}
-		writer.put((byte) netFlags);
-		writer.put3(roadLength);
+		writer.put1u(netFlags);
+		writer.put3u(roadLength);
 
 		int maxlevel = writeLevelCount(writer);
 
@@ -235,9 +235,9 @@
 			if (nodeCount + 2 != nnodes){
 				log.error("internal error? The nodeCount doesn't match value calculated by RoadNetWork:",this);
 			}
-			writer.put((byte) (nodeCount & 0xff)); // lo bits of node count
+			writer.put1u(nodeCount); // lo bits of node count
 
-			int code = ((nodeCount >> 8) & 0x3); // top bits of node count
+			int code = (nodeCount >> 8) & 0x3; // top bits of node count
 			int len, flag;
 			
 			ByteArrayOutputStream zipBuf = null, cityBuf = null;
@@ -264,32 +264,32 @@
 				flag = 3;
 			code |= flag << 6;
 			
-			writer.put((byte)code);
+			writer.put1u(code);
 //			System.out.printf("%d %d %d\n", (code >> 2 & 0x3), (code >> 4 & 0x3), (code >> 6 & 0x3));  
 			
 			if (zipBuf != null){
 				len = zipBuf.size();
-				writer.putN(Utils.numberToPointerSize(len), len);
+				writer.putNu(Utils.numberToPointerSize(len), len);
 				writer.put(zipBuf.toByteArray());
 			} else {
 				if(zip != null) {
-					char zipIndex = (char)zip.getIndex();
-					writer.putN(Utils.numberToPointerSize(numZips), zipIndex);
+					int zipIndex = zip.getIndex();
+					writer.putNu(Utils.numberToPointerSize(numZips), zipIndex);
 				}
 			}
 			if (cityBuf != null){
 				len = cityBuf.size();
-				writer.putN(Utils.numberToPointerSize(len), len);
+				writer.putNu(Utils.numberToPointerSize(len), len);
 				writer.put(cityBuf.toByteArray());
 			} else {
 				if(city != null) {
-					char cityIndex = (char)city.getIndex();
-					writer.putN(Utils.numberToPointerSize(numCities), cityIndex);
+					int cityIndex = city.getIndex();
+					writer.putNu(Utils.numberToPointerSize(numCities), cityIndex);
 				}
 			}
 			if (numbers != null) {
 				BitWriter bw = numbers.fetchBitStream();
-				writer.putN(Utils.numberToPointerSize(bw.getLength()), bw.getLength());
+				writer.putNu(Utils.numberToPointerSize(bw.getLength()), bw.getLength());
 				writer.put(bw.getBytes(), 0, bw.getLength());
 			}
 		}
@@ -298,11 +298,11 @@
 			// This is the offset of an entry in NOD2
 			int val = offsetNod2;
 			if (val < 0x7fff) {
-				writer.put((byte) 1);
-				writer.putChar((char) val);
+				writer.put1u(1);
+				writer.put2u(val);
 			} else {
-				writer.put((byte) 2);
-				writer.put3(val);
+				writer.put1u(2);
+				writer.put3u(val);
 			}
 		}
 	}
@@ -313,7 +313,7 @@
 			int ptr = l.getOffset();
 			if (i == (numlabels-1))
 				ptr |= 0x800000;
-			writer.put3(ptr);
+			writer.put3u(ptr);
 		}
 	}
 
@@ -320,7 +320,7 @@
 	public void putSortedRoadEntry(ImgFileWriter writer, Label label) {
 		for(int i = 0; i < labels.length && labels[i] != null; ++i) {
 			if(labels[i].equals(label)) {
-				writer.put3((i << 22) | offsetNet1);
+				writer.put3u((i << 22) | offsetNet1);
 				return;
 			}
 		}
@@ -334,7 +334,7 @@
 			assert b < 0x80 : "too many polylines at level " + i;
 			if (i == maxlevel)
 				b |= 0x80;
-			writer.put((byte) b);
+			writer.put1u(b);
 		}
 		return maxlevel;
 	}
@@ -479,7 +479,7 @@
 
 		for (Offset off : rgnOffsets) {
 			rgn.position(off.getPosition());
-			rgn.put3(offsetNet1 | off.getFlags());
+			rgn.put3u(offsetNet1 | off.getFlags());
 		}
 	}
 
@@ -561,8 +561,8 @@
 
 		offsetNod2 = writer.position();
 
-		writer.put((byte) nod2Flags);
-		writer.put3(node.getOffsetNod1()); // offset in nod1
+		writer.put1u(nod2Flags);
+		writer.put3u(node.getOffsetNod1()); // offset in nod1
 
 		// this is related to the number of nodes, but there
 		// is more to it...
@@ -573,7 +573,7 @@
 		int nbits = nnodes;
 		if (!startsWithNode)
 			nbits++;
-		writer.putChar((char) nbits);
+		writer.put2u(nbits);
 		boolean[] bits = new boolean[nbits];
 		
 		if (hasHouseNumbers()){
@@ -593,7 +593,7 @@
             for (int j = 0; j < 8 && j < bits.length - i; j++)
 				if (bits[i+j])
 					b |= 1 << j;
-			writer.put((byte) b);
+			writer.put1u(b);
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/net/RoadIndex.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/RoadIndex.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/RoadIndex.java	(working copy)
@@ -43,8 +43,8 @@
 	void write(ImgFileWriter writer) {
 		int roadnum = linkedRoad.getNumber();
 		assert roadnum < 256;
-		writer.put((byte) roadnum);
-		char subdivnum = (char) getSubdiv().getNumber();
-		writer.putChar(subdivnum);
+		writer.put1u(roadnum);
+		int subdivnum = getSubdiv().getNumber();
+		writer.put2u(subdivnum);
 	}
 }
Index: src/uk/me/parabola/imgfmt/app/net/RouteArc.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/net/RouteArc.java	(revision 4130)
+++ src/uk/me/parabola/imgfmt/app/net/RouteArc.java	(working copy)
@@ -52,12 +52,12 @@
 	private final RouteNode dest;
 
 	// The index in Table A describing this arc.
-	private byte indexA;
+	private int indexA;
 	// The index in Table B that this arc goes via, if external.
-	private byte indexB;
+	private int indexB;
 	
-	private byte flagA;
-	private byte flagB;
+	private int flagA;
+	private int flagB;
 
 	private final boolean haveCurve;
 	private final int length;
@@ -192,7 +192,7 @@
 	/**
 	 * Set this arc's index into Table A.
 	 */
-	public void setIndexA(byte indexA) {
+	public void setIndexA(int indexA) {
 		this.indexA = indexA;
 	}
 
@@ -201,7 +201,7 @@
 	 *
 	 * Required for writing restrictions (Table C).
 	 */
-	public byte getIndexA() {
+	public int getIndexA() {
 		return indexA;
 	}
 
@@ -208,7 +208,7 @@
 	/**
 	 * Set this arc's index into Table B. Applies to external arcs only.
 	 */
-	public void setIndexB(byte indexB) {
+	public void setIndexB(int indexB) {
 		assert !isInternal() : "Trying to set index on internal arc.";
 		this.indexB = indexB;
 	}
@@ -219,7 +219,7 @@
 	 * Required for writing restrictions (Table C).
 	 */
 	public int getIndexB() {
-		return indexB & 0xff;
+		return indexB; // ??? & 0xff;
 	}
 	 
 	public int getArcDestClass(){
@@ -258,23 +258,23 @@
 		// determine how to write length and curve bit
 		int[] lendat = encodeLength();
 
-		writer.put(flagA);
+		writer.put1u(flagA);
 		if (isInternal()) {
 			// space for 14 bit node offset, written in writeSecond.
-			writer.put(flagB);
-			writer.put((byte) 0);
+			writer.put1u(flagB);
+			writer.put1u(0);
 		} else {
 			if(indexB < 0 || indexB >= 0x3f) {
-				writer.put((byte) (flagB | 0x3f));
-				writer.put(indexB);
+				writer.put1u(flagB | 0x3f);
+				writer.put1u(indexB);
 			}
 			else
-				writer.put((byte) (flagB | indexB));
+				writer.put1u(flagB | indexB);
 		}
 		
 		 // only write out the local net index if it is the first arc or else if newDir is set.
 		if (first || lastArc.indexA != this.indexA)
-			writer.put(indexA);
+			writer.put1u(indexA);
 
 		if(log.isDebugEnabled())
 			log.debug("writing length", length);
@@ -285,7 +285,7 @@
 			if (useCompactDirs){
 				// determine if we have to write direction info
 				if (compactedDir != null)
-					writer.put(compactedDir);
+					writer.put(compactedDir); // composite byte = dont check
 			} else 
 				writer.put(directionFromDegrees(initialHeading));
 		} else {
@@ -294,7 +294,7 @@
 		if (haveCurve) {
 			int[] curvedat = encodeCurve();
 			for (int aCurvedat : curvedat)
-				writer.put((byte) aCurvedat);
+			    writer.put((byte) aCurvedat);
 		}
 	}
 
@@ -308,7 +308,7 @@
 			return;
 
 		writer.position(offset + 1);
-		char val = (char) (flagB << 8);
+		int val = flagB << 8;
 		int diff = dest.getOffsetNod1() - source.getOffsetNod1();
 		assert diff < 0x2000 && diff >= -0x2000
 			: "relative pointer too large for 14 bits (source offset = " + source.getOffsetNod1() + ", dest offset = " + dest.getOffsetNod1() + ")";
@@ -317,8 +317,8 @@
 		// We write this big endian
 		if(log.isDebugEnabled())
 			log.debug("val is", Integer.toHexString((int)val));
-		writer.put((byte) (val >> 8));
-		writer.put((byte) val);
+		writer.put1u(val >> 8);
+		writer.put1u(val & 0xff);
 	}
 
 	/*
